.386
;                INCLUDE BITBLT.INC

_TEXT           SEGMENT WORD PUBLIC USE16 'CODE'

PUBLIC  xlateRop
PUBLIC  LeftMask1
PUBLIC  RightMask1
;----------------------------------------------------------------------------;
;                                                                            ;
; The ROP translation table represents a ternery ROP as a polynomial with    ;
; terms that describe all the combinations of source, pattern, and           ;
; destination.  The bits in the translated rop correspond to the presence or ;
; absence of the term in the evaluated polynomial.  The polynomial is        ;
; described as:                                                              ;
;                                                                            ;
; Rop(D,S,P) = a + a D + a S + a P + a  DS + a  DP + a  SP + a   DSP         ;
;               n   d     s     p     ds      dp      sp      dsp            ;
;                                                                            ;
; The terms are evaluated as:                                                ;
;                                                                            ;
;          a           ~                                                     ;
;           n                                                                ;
;                                                                            ;
;          a           ^ DST                                                 ;
;           d                                                                ;
;                                                                            ;
;          a           ^ SRC                                                 ;
;           s                                                                ;
;                                                                            ;
;          a           ^ PAT                                                 ;
;           p                                                                ;
;                                                                            ;
;          a           ^ (DST & SRC)                                         ;
;           ds                                                               ;
;                                                                            ;
;          a           ^ (DST & PAT)                                         ;
;           dp                                                               ;
;                                                                            ;
;          a           ^ (SRC & PAT)                                         ;
;           sp                                                               ;
;                                                                            ;
;          a           ^ (DST & SRC & PAT)                                   ;
;           dsp                                                              ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
; This table snagged from the NT VGA driver                                  ;
;                                                                            ;
;----------------------------------------------------------------------------;

xlateRop        DB      000h, 0FFh, 0B2h, 04Dh, 0D4h, 02Bh, 066h, 099h
                DB      090h, 06Fh, 022h, 0DDh, 044h, 0BBh, 0F6h, 009h
                DB      0E8h, 017h, 05Ah, 0A5h, 03Ch, 0C3h, 08Eh, 071h
                DB      078h, 087h, 0CAh, 035h, 0ACh, 053h, 01Eh, 0E1h
                DB      0A0h, 05Fh, 012h, 0EDh, 074h, 08Bh, 0C6h, 039h
                DB      030h, 0CFh, 082h, 07Dh, 0E4h, 01Bh, 056h, 0A9h
                DB      048h, 0B7h, 0FAh, 005h, 09Ch, 063h, 02Eh, 0D1h
                DB      0D8h, 027h, 06Ah, 095h, 00Ch, 0F3h, 0BEh, 041h
                DB      0C0h, 03Fh, 072h, 08Dh, 014h, 0EBh, 0A6h, 059h
                DB      050h, 0AFh, 0E2h, 01Dh, 084h, 07Bh, 036h, 0C9h
                DB      028h, 0D7h, 09Ah, 065h, 0FCh, 003h, 04Eh, 0B1h
                DB      0B8h, 047h, 00Ah, 0F5h, 06Ch, 093h, 0DEh, 021h
                DB      060h, 09Fh, 0D2h, 02Dh, 0B4h, 04Bh, 006h, 0F9h
                DB      0F0h, 00Fh, 042h, 0BDh, 024h, 0DBh, 096h, 069h
                DB      088h, 077h, 03Ah, 0C5h, 05Ch, 0A3h, 0EEh, 011h
                DB      018h, 0E7h, 0AAh, 055h, 0CCh, 033h, 07Eh, 081h
                DB      080h, 07Fh, 032h, 0CDh, 054h, 0ABh, 0E6h, 019h
                DB      010h, 0EFh, 0A2h, 05Dh, 0C4h, 03Bh, 076h, 089h
                DB      068h, 097h, 0DAh, 025h, 0BCh, 043h, 00Eh, 0F1h
                DB      0F8h, 007h, 04Ah, 0B5h, 02Ch, 0D3h, 09Eh, 061h
                DB      020h, 0DFh, 092h, 06Dh, 0F4h, 00Bh, 046h, 0B9h
                DB      0B0h, 04Fh, 002h, 0FDh, 064h, 09Bh, 0D6h, 029h
                DB      0C8h, 037h, 07Ah, 085h, 01Ch, 0E3h, 0AEh, 051h
                DB      058h, 0A7h, 0EAh, 015h, 08Ch, 073h, 03Eh, 0C1h
                DB      040h, 0BFh, 0F2h, 00Dh, 094h, 06Bh, 026h, 0D9h
                DB      0D0h, 02Fh, 062h, 09Dh, 004h, 0FBh, 0B6h, 049h
                DB      0A8h, 057h, 01Ah, 0E5h, 07Ch, 083h, 0CEh, 031h
                DB      038h, 0C7h, 08Ah, 075h, 0ECh, 013h, 05Eh, 0A1h
                DB      0E0h, 01Fh, 052h, 0ADh, 034h, 0CBh, 086h, 079h
                DB      070h, 08Fh, 0C2h, 03Dh, 0A4h, 05Bh, 016h, 0E9h
                DB      008h, 0F7h, 0BAh, 045h, 0DCh, 023h, 06Eh, 091h
                DB      098h, 067h, 02Ah, 0D5h, 04Ch, 0B3h, 0FEh, 001h

LeftMask1       DB      0FFh, 07Fh, 03Fh, 01Fh
                DB      00Fh, 007h, 003h, 001h

RightMask1      DB      080h, 0C0h, 0E0h, 0F0h
                DB      0F8h, 0FCh, 0FEh, 0FFh

_TEXT           ENDS
                END
